{--------------------------------------------------------}
{
{      Processador de Scripts
{
{      Autor: Jos Antonio Borges
{
{      Em 25/6/2000
{
{--------------------------------------------------------}
program scripVox;
uses
    windows, classes, sysUtils,
    dvwin, dvcrt, dvarq, dvscript in '.\dvscript.pas', dvform, dvmsaa, activeX,midi;
const versao = '5.2b13';
var
    nomeArq, rotulo: string;
    arq: text;
    interativo: boolean;
{--------------------------------------------------------}
{                 fala uma mensagem
{--------------------------------------------------------}
procedure mensagem (nomeArq: string; apular: integer);
var i: integer;
    s: string;
begin
    if nomeArq = 'SCINIC' then
        s := 'ScriptVox - v'
    else
    if nomeArq = 'SCNOMARQ' then
        s := 'Nome do arquivo .CMD a executar: '
    else
    if nomeArq = 'SCFIM' then
        s := 'Fim do script'
    else
    if nomeArq = 'SCARQNAO' then
        s := 'Arquivo .CMD inexistente'
    else
    if nomeArq = 'SCERREXE' then
        s := 'Erro de execuo na linha '
    else
    if nomeArq = 'SCERRROT' then
        s := 'Este rtulo no existe !'
    else
    if nomeArq = 'SCERRO' then
        s := 'Erro'
    else
    if nomeArq = 'SCEDITE' then
        s := 'Editore e aperte enter'
    else
    if nomeArq = 'SCINTER' then
        s := 'Modo interativo'
    else
        begin
            writeln;
            writeln ('-------------------------------');
            writeln ('--- mensagem errada: ', s, '---');
            writeln ('-------------------------------');
            writeln;
        end;
    write (s);
    for i := 1 to apular do writeln;
    if existeArqSom (nomeArq) then
        sintsom (nomeArq)
    else
        sintetiza (s);
end;
{--------------------------------------------------------}
{      remove brancos ao inicio e fim de uma cadeia
{--------------------------------------------------------}
procedure trim (var lido: string);
begin
    while (lido <> '') and (lido[1] = ' ') do
        delete (lido, 1, 1);
    while (lido <> '') and (lido[length(lido)] = ' ') do
        delete (lido, length(lido), 1);
end;
{--------------------------------------------------------}
{             transforma cadeia em maiusculos
{--------------------------------------------------------}
function maiusc (s: string): string;
begin
    s := s + #$0;
    ansiUpper (@s[1]);
    delete (s, length (s), 1);
    maiusc := s;
end;
{--------------------------------------------------------}
{                    inicializao
{--------------------------------------------------------}
function inicializa: boolean;
var s: string;
    dirAtual: string;
    p: integer;
label deNovo;
begin
    CoInitialize(NIL);
    inicializa := true;
    sintInic (0, sintAmbiente ('SCRIPVOX', 'DIRSCRIPVOX'));
    clrscr;
    setWindowText (crtWindow, 'SCRIPVOX');
    if paramCount <> 0 then
        nomeArq := paramStr(1)
    else
        begin
            textBackground (BLUE);
            mensagem ('SCINIC', 0);   {'ScriptVox - v'}
             sintwriteln(versao);
            textBackground (BLACK);
            writeln;
            getDir (0, dirAtual);
            s := sintAmbiente ('SCRIPVOX', 'DIRDEFAULT');
            if s = '' then s := 'c:\winvox\scripts';
            {$I-}  chdir (s);  {$I+}
            if ioresult <> 0 then ;
            mensagem ('SCNOMARQ', 0);    {'Nome do arquivo .CMD ou .PRO a executar: '}
            nomeArq := obtemNomeArq (20);
            trim (nomeArq);
            writeln (nomeArq);
            if teclaObtemNomeArq = ESC then
                begin
                    sintFim;
                    doneWinCrt;
                end;
            chDir (dirAtual);
        end;
    interativo := false;
    if nomeArq = '' then
        begin
            s := 'SCRIPVOX (interativo)';
            setWindowText (crtWindow, @s[1]);
            interativo := true;
            exit;
        end;
    rotulo := '';
    p := pos ('@', nomeArq);
    if p <> 0 then
        begin
            rotulo := copy (nomeArq, p+1, 999);
            delete (nomeArq, p, 999);
            trim (nomeArq);
            trim (rotulo);
        end;
    s := 'SCRIPVOX ' + nomeArq;
    setWindowText (crtWindow, @s[1]);
deNovo:
    assign (arq, nomeArq);
    {$I-}  reset (arq);  {$I+}
    if ioresult = 0 then
        begin
            close (arq);
            exit;
        end
    else
        begin
            if (maiusc (copy (nomeArq, length(nomeArq)-3, 4)) <> '.CMD') and
               (maiusc (copy (nomeArq, length(nomeArq)-3, 4)) <> '.PRO') then
                begin
                    nomeArq := nomeArq + '.CMD';
                    goto deNovo;
                end;
        end;
    if pos ('\', nomeArq) = 0 then
        begin
            s := sintAmbiente ('SCRIPVOX', 'DIRDEFAULT');
            if s = '' then s := '.';
            if s [length(s)] <> '\' then s := s + '\';
            nomeArq := s + nomeArq;
            assign (arq, nomeArq);
            if fileExists (nomeArq) then
                exit;
        end;
    mensagem ('SCARQNAO', 1);   {'Arquivo .CMD inexistente'}
    inicializa := false;
end;
{--------------------------------------------------------}
{                    processamento
{--------------------------------------------------------}
procedure processaInterativo;
var c: char;
    i: integer;
    listaCmd: TStringList;
    lido: string;
begin
    mensagem ('SCINTER', 2);    {'Modo interativo'}
    listaCmd := TStringList.create;
    fimScript := false;
    while not fimScript do
        begin
            lido := '';
            repeat
                c := sintEdita(lido, wherex, wherey, 255, true);
                writeln;
                if c = ESC then
                    fimScript := true
                else
                if (c = CIMA) or (c = BAIX) then
                    begin
                        garanteEspacoTela (5);
                        popupMenuCria(wherex, wherey, 80, listaCmd.Count, RED);
                        for i := 0 to listaCmd.Count-1 do
                            popupMenuAdiciona('', listaCmd[i]);
                        i := popupMenuSeleciona;
                        if i >= 1 then
                            begin
                                lido := opcoesItemSelecionado;
                                mensagem ('SCEDITE', 1);
                            end;
                    end;
            until (c = ENTER) or (c = ESC);
            if not fimScript then
                begin
                    if listaCmd.Count = 0 then
                        listaCmd.Add(lido)
                    else
                        listaCmd.Insert(0, lido);
                    if not cmdScript (lido) then
                        mensagem ('SCERRO', 1);   {'Erro'}
                    lido := '';
                end;
        end;
    if not fimScriptMudo then
        mensagem ('SCFIM', 1);   {'Fim do script'}
end;
{--------------------------------------------------------}
{                    processamento
{--------------------------------------------------------}
procedure processa;
var retorno, ultLinProc: integer;
begin
    retorno := executaScript (nomeArq, rotulo, ultLinProc);
    case retorno of
        SCR_OK:
            if not fimScriptMudo then
                mensagem ('SCFIM', 1);   {'Fim do script'}
        SCR_ERROEXEC:
            begin
                showWindow (crtWindow, SW_RESTORE);
                mensagem ('SCERREXE', 0);   {'Erro de execuo na linha '}
                sintWriteint (ultLinProc);
                writeln;
                readln;
            end;
        SCR_SEMARQUIVO:
            mensagem ('SCARQNAO', 1);   {'Arquivo inexistente'}
        SCR_ROTULOINVALIDO:
            mensagem ('SCERRROT', 1);   {''Este rtulo no existe !'}
    end;
end;
{--------------------------------------------------------}
{                      finalizao
{--------------------------------------------------------}
procedure finaliza;
begin
    CoUnInitialize;
    sintFim;
    doneWinCrt;
end;
{--------------------------------------------------------}
{                     processamento
{--------------------------------------------------------}
begin
    if inicializa then
        if interativo then
            processaInterativo
        else
            processa
    else
        delay (2000);
    finaliza;
end.
